---
title: 'TypeError: property "x" is non-configurable and can''t be deleted'
slug: Web/JavaScript/Reference/Errors/Cant_delete
tags:
  - Error
  - Errors
  - JavaScript
  - Strict Mode
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "property is non-configurable and can't be deleted" occurs when it was attempted to delete a property, but that property is <a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">non-configurable</a>.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: Calling delete on 'x' is not allowed in strict mode (Edge)
TypeError: property "x" is non-configurable and can't be deleted. (Firefox)
TypeError: Cannot delete property 'x' of #&lt;Object&gt; (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}} in strict mode only.</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>It was attempted to delete a property, but that property is <a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">non-configurable</a>. The <code>configurable</code> attribute controls whether the property can be deleted from the object and whether its attributes (other than <code>writable</code>) can be changed.</p>

<p>This error happens only in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode code</a>. In non-strict code, the operation returns <code>false</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Attempting_to_delete_non-configurable_properties">Attempting to delete non-configurable properties</h3>

<p>Non-configurable properties are not super common, but they can be created using {{jsxref("Object.defineProperty()")}} or {{jsxref("Object.freeze()")}}.</p>

<pre class="brush: js example-bad">'use strict';
var obj = Object.freeze({name: 'Elsa', score: 157});
delete obj.score;  // TypeError

'use strict';
var obj = {};
Object.defineProperty(obj, 'foo', {value: 2, configurable: false});
delete obj.foo;  // TypeError

'use strict';
var frozenArray = Object.freeze([0, 1, 2]);
frozenArray.pop();  // TypeError
</pre>

<p>There are also a few non-configurable properties built into JavaScript. Maybe you tried to delete a mathematical constant.</p>

<pre class="brush: js example-bad">'use strict';
delete Math.PI;  // TypeError</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete operator</a></li>
 <li>{{jsxref("Object.defineProperty()")}}</li>
 <li>{{jsxref("Object.freeze()")}}</li>
</ul>
